# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conint
from pypureclient.flasharray.FA_2_0.models.qos import Qos
from pypureclient.flasharray.FA_2_0.models.reference import Reference


class VolumePatch(BaseModel):
    """
    VolumePatch
    """
    destroyed: Optional[StrictBool] = Field(default=None, description="If set to `true`, destroys a resource. Once set to `true`, the `time_remaining` value will display the amount of time left until the destroyed resource is permanently eradicated. Before the `time_remaining` period has elapsed, the destroyed resource can be recovered by setting `destroyed=false`. Once the `time_remaining` period has elapsed, the resource is permanently eradicated and can no longer be recovered.")
    name: Optional[StrictStr] = Field(default=None, description="The new name for the resource.")
    pod: Optional[Reference] = Field(default=None, description="Moves the volume into the specified pod.")
    provisioned: Optional[conint(strict=True, le=4503599627370496)] = Field(default=None, description="Updates the virtual size of the volume. Measured in bytes.")
    qos: Optional[Qos] = Field(default=None, description="Sets QoS limits.")
    volume_group: Optional[Reference] = Field(default=None, description="Adds the volume to the specified volume group.")
    __properties = ["destroyed", "name", "pod", "provisioned", "qos", "volume_group"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of pod
        if _include_in_dict('pod', include_readonly, excluded_fields, none_fields):
            _dict['pod'] = self.pod.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of qos
        if _include_in_dict('qos', include_readonly, excluded_fields, none_fields):
            _dict['qos'] = self.qos.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of volume_group
        if _include_in_dict('volume_group', include_readonly, excluded_fields, none_fields):
            _dict['volume_group'] = self.volume_group.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> VolumePatch:
        """Create an instance of VolumePatch from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> VolumePatch:
        """Create an instance of VolumePatch from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return VolumePatch.parse_obj(obj)

        _obj = VolumePatch.construct(_fields_set=None, **{
            "destroyed": obj.get("destroyed"),
            "name": obj.get("name"),
            "pod": Reference.from_dict(obj.get("pod")) if obj.get("pod") is not None else None,
            "provisioned": obj.get("provisioned"),
            "qos": Qos.from_dict(obj.get("qos")) if obj.get("qos") is not None else None,
            "volume_group": Reference.from_dict(obj.get("volume_group")) if obj.get("volume_group") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

