# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.28
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr


class KmipTestResult(BaseModel):
    """
    KmipTestResult
    """
    component_address: Optional[StrictStr] = Field(default=None, description="Address of the component running the test.")
    component_name: Optional[StrictStr] = Field(default=None, description="Name of the component running the test.")
    description: Optional[StrictStr] = Field(default=None, description="Description of what is being tested.")
    destination: Optional[StrictStr] = Field(default=None, description="The URI of the target server being tested.")
    enabled: Optional[StrictBool] = Field(default=None, description="Expresses whether the service is enabled or not.")
    result_details: Optional[StrictStr] = Field(default=None, description="Additional information about the test result.")
    success: Optional[StrictBool] = Field(default=None, description="Expresses whether communication between the FlashArray and the KMIP server succeeded or not.")
    test_type: Optional[StrictStr] = Field(default=None, description="Description of what is being tested.")
    __properties = ["component_address", "component_name", "description", "destination", "enabled", "result_details", "success", "test_type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> KmipTestResult:
        """Create an instance of KmipTestResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> KmipTestResult:
        """Create an instance of KmipTestResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return KmipTestResult.parse_obj(obj)

        _obj = KmipTestResult.construct(_fields_set=None, **{
            "component_address": obj.get("component_address"),
            "component_name": obj.get("component_name"),
            "description": obj.get("description"),
            "destination": obj.get("destination"),
            "enabled": obj.get("enabled"),
            "result_details": obj.get("result_details"),
            "success": obj.get("success"),
            "test_type": obj.get("test_type")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

