# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.29
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conint, conlist
from pypureclient.flasharray.FA_2_29.models.fixed_reference import FixedReference
from pypureclient.flasharray.FA_2_29.models.pod_array_status import PodArrayStatus
from pypureclient.flasharray.FA_2_29.models.pod_eradication_config import PodEradicationConfig
from pypureclient.flasharray.FA_2_29.models.pod_space import PodSpace
from pypureclient.flasharray.FA_2_29.models.reference import Reference


class Pod(BaseModel):
    """
    Pod
    """
    id: Optional[StrictStr] = Field(default=None, description="A globally unique, system-generated ID. The ID cannot be modified and cannot refer to another resource.")
    name: Optional[StrictStr] = Field(default=None, description="A user-specified name. The name must be locally unique and can be changed.")
    array_count: Optional[StrictInt] = Field(default=None, description="The number of arrays a pod connects to.")
    arrays: Optional[conlist(PodArrayStatus, min_items=1)] = Field(default=None, description="A list of arrays over which the pod is stretched. If there are two or more arrays in the stretched pod, all data in the pod is synchronously replicated between all of the arrays within the pod.")
    destroyed: Optional[StrictBool] = Field(default=None, description="Returns a value of `true` if the pod has been destroyed and is pending eradication. The `time_remaining` value displays the amount of time left until the destroyed pod is permanently eradicated. Before the `time_remaining` period has elapsed, the destroyed pod can be recovered by setting `destroyed=false`. Once the `time_remaining` period has elapsed, the pod is permanently eradicated and can no longer be recovered.")
    eradication_config: Optional[PodEradicationConfig] = None
    failover_preferences: Optional[conlist(Reference)] = Field(default=None, description="Determines which array within a stretched pod should be given priority to stay online should the arrays ever lose contact with each other. The current array and any peer arrays that are connected to the current array for synchronous replication can be added to a pod for failover preference. By default, `failover_preferences=null`, meaning no arrays have been configured for failover preference.")
    footprint: Optional[conint(strict=True, ge=0)] = Field(default=None, description="The maximum amount of physical space the pod would take up on any array, ignoring any data shared outside the pod. Measured in bytes. The footprint metric is mostly used for capacity planning.")
    link_source_count: Optional[StrictInt] = Field(default=None, description="The number of source pods that link to the pod.")
    link_target_count: Optional[StrictInt] = Field(default=None, description="The number of target pods that link to the pod.")
    mediator: Optional[StrictStr] = Field(default=None, description="The URL of the mediator for the pod. By default, the Pure1 Cloud Mediator (`purestorage`) serves as the mediator.")
    mediator_version: Optional[StrictStr] = Field(default=None, description="The mediator version.")
    promotion_status: Optional[StrictStr] = Field(default=None, description="Current promotion status of a pod. Values include `promoted`, `demoted`, and `promoting`. The `promoted` status indicates that the pod has been promoted. The pod takes writes from hosts instead of incorporating replicated data. This is the default mode for a pod when it is created. The `demoted` status indicates that the pod has been demoted. The pod does not accept write requests and is ready to be used as a link target. The `promoting` status indicates that the pod is in an intermediate status between `demoted` and `promoted` while the promotion process is taking place.")
    quota_limit: Optional[conint(strict=True, le=4503599627370496)] = Field(default=None, description="The logical quota limit of the pod, measured in bytes.")
    requested_promotion_state: Optional[StrictStr] = Field(default=None, description="Values include `promoted` and `demoted`. Patch `requested_promotion_state` to `demoted` to demote the pod so that it can be used as a link target for continuous replication between pods. Demoted pods do not accept write requests, and a destroyed version of the pod with `undo-demote` appended to the pod name is created on the array with the state of the pod when it was in the promoted state. Patch `requested_promotion_state` to `promoted` to start the process of promoting the pod. The `promotion_status` indicates when the pod has been successfully promoted. Promoted pods stop incorporating replicated data from the source pod and start accepting write requests. The replication process does not stop as the source pod continues replicating data to the pod. The space consumed by the unique replicated data is tracked by the `space.journal` field of the pod.")
    source: Optional[FixedReference] = Field(default=None, description="The source pod from where data is cloned to create the new pod.")
    space: Optional[PodSpace] = Field(default=None, description="Displays provisioned size and physical storage consumption information for the sum of all volumes connected to the specified host.")
    time_remaining: Optional[StrictInt] = Field(default=None, description="The amount of time left until the destroyed pod is permanently eradicated, measured in milliseconds. Before the `time_remaining` period has elapsed, the destroyed pod can be recovered by setting `destroyed=false`.")
    __properties = ["id", "name", "array_count", "arrays", "destroyed", "eradication_config", "failover_preferences", "footprint", "link_source_count", "link_target_count", "mediator", "mediator_version", "promotion_status", "quota_limit", "requested_promotion_state", "source", "space", "time_remaining"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "quota_limit",
                "time_remaining",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in arrays (list)
        if _include_in_dict('arrays', include_readonly, excluded_fields, none_fields):
            _items = []
            for _item in self.arrays:
                if _item:
                    _items.append(_item.to_dict(include_readonly=include_readonly))
            _dict['arrays'] = _items
        # override the default output from pydantic by calling `to_dict()` of eradication_config
        if _include_in_dict('eradication_config', include_readonly, excluded_fields, none_fields):
            _dict['eradication_config'] = self.eradication_config.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of each item in failover_preferences (list)
        if _include_in_dict('failover_preferences', include_readonly, excluded_fields, none_fields):
            _items = []
            for _item in self.failover_preferences:
                if _item:
                    _items.append(_item.to_dict(include_readonly=include_readonly))
            _dict['failover_preferences'] = _items
        # override the default output from pydantic by calling `to_dict()` of source
        if _include_in_dict('source', include_readonly, excluded_fields, none_fields):
            _dict['source'] = self.source.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of space
        if _include_in_dict('space', include_readonly, excluded_fields, none_fields):
            _dict['space'] = self.space.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> Pod:
        """Create an instance of Pod from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> Pod:
        """Create an instance of Pod from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Pod.parse_obj(obj)

        _obj = Pod.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "array_count": obj.get("array_count"),
            "arrays": [PodArrayStatus.from_dict(_item) for _item in obj.get("arrays")] if obj.get("arrays") is not None else None,
            "destroyed": obj.get("destroyed"),
            "eradication_config": PodEradicationConfig.from_dict(obj.get("eradication_config")) if obj.get("eradication_config") is not None else None,
            "failover_preferences": [Reference.from_dict(_item) for _item in obj.get("failover_preferences")] if obj.get("failover_preferences") is not None else None,
            "footprint": obj.get("footprint"),
            "link_source_count": obj.get("link_source_count"),
            "link_target_count": obj.get("link_target_count"),
            "mediator": obj.get("mediator"),
            "mediator_version": obj.get("mediator_version"),
            "promotion_status": obj.get("promotion_status"),
            "quota_limit": obj.get("quota_limit"),
            "requested_promotion_state": obj.get("requested_promotion_state"),
            "source": FixedReference.from_dict(obj.get("source")) if obj.get("source") is not None else None,
            "space": PodSpace.from_dict(obj.get("space")) if obj.get("space") is not None else None,
            "time_remaining": obj.get("time_remaining")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

