# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.31
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt
from pypureclient.flasharray.FA_2_31.models.fixed_reference_with_type import FixedReferenceWithType


class LocalMember(BaseModel):
    """
    LocalMember
    """
    group: Optional[FixedReferenceWithType] = Field(default=None, description="Reference to the group to which the member belongs.")
    group_gid: Optional[StrictInt] = Field(default=None, description="GID of the group to which the member belongs.")
    is_primary_group: Optional[StrictBool] = Field(default=None, description="When a membership of `member_type` has the value `User`, this specifies whether this membership is a primary-group mapping or not. In any other case, this field will be `false`.")
    member: Optional[FixedReferenceWithType] = Field(default=None, description="Reference to the member of the group.")
    member_id: Optional[StrictInt] = Field(default=None, description="GID if the `member_type` is `Group` and UID if the `member_type` is `User`.")
    __properties = ["group", "group_gid", "is_primary_group", "member", "member_id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "is_primary_group",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of group
        if _include_in_dict('group', include_readonly, excluded_fields, none_fields):
            _dict['group'] = self.group.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of member
        if _include_in_dict('member', include_readonly, excluded_fields, none_fields):
            _dict['member'] = self.member.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> LocalMember:
        """Create an instance of LocalMember from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> LocalMember:
        """Create an instance of LocalMember from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LocalMember.parse_obj(obj)

        _obj = LocalMember.construct(_fields_set=None, **{
            "group": FixedReferenceWithType.from_dict(obj.get("group")) if obj.get("group") is not None else None,
            "group_gid": obj.get("group_gid"),
            "is_primary_group": obj.get("is_primary_group"),
            "member": FixedReferenceWithType.from_dict(obj.get("member")) if obj.get("member") is not None else None,
            "member_id": obj.get("member_id")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

