# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.32
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from pypureclient.flasharray.FA_2_32.models.software_checks_checks import SoftwareChecksChecks


class SoftwareCheck(BaseModel):
    """
    SoftwareCheck
    """
    id: Optional[StrictStr] = Field(default=None, description="A globally unique, system-generated ID. The ID cannot be modified.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the resource. The name cannot be modified.")
    end_time: Optional[StrictInt] = Field(default=None, description="End time in milliseconds since the UNIX epoch.")
    start_time: Optional[StrictInt] = Field(default=None, description="Start time in milliseconds since the UNIX epoch.")
    checks: Optional[conlist(SoftwareChecksChecks)] = Field(default=None, description="A list of checks in this check task.")
    details: Optional[StrictStr] = Field(default=None, description="The detailed reason for the `status`.")
    software_name: Optional[StrictStr] = Field(default=None, description="The name of the software the upgrade checks will test.")
    software_upgrade_hops: Optional[conlist(StrictStr)] = Field(default=None, description="The list of software versions the upgrade goes through. The upgrade checks also test this particular path.")
    software_version: Optional[StrictStr] = Field(default=None, description="The version of the software that the upgrade checks will test.")
    status: Optional[StrictStr] = Field(default=None, description="The status of the check task. Valid values are `queued`, `running`, `passed`, and `failed`. A status of `queued` indicates that the task is queued to run and is waiting for other check tasks to complete. A status of `running` indicates that the task is currently running. A status of `passed` indicates that all upgrade checks in the task are complete. A status of `failed` indicates that at least one upgrade check in the task has failed.")
    __properties = ["id", "name", "end_time", "start_time", "checks", "details", "software_name", "software_upgrade_hops", "software_version", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "name",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in checks (list)
        if _include_in_dict('checks', include_readonly, excluded_fields, none_fields):
            _items = []
            for _item in self.checks:
                if _item:
                    _items.append(_item.to_dict(include_readonly=include_readonly))
            _dict['checks'] = _items
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> SoftwareCheck:
        """Create an instance of SoftwareCheck from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> SoftwareCheck:
        """Create an instance of SoftwareCheck from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SoftwareCheck.parse_obj(obj)

        _obj = SoftwareCheck.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "end_time": obj.get("end_time"),
            "start_time": obj.get("start_time"),
            "checks": [SoftwareChecksChecks.from_dict(_item) for _item in obj.get("checks")] if obj.get("checks") is not None else None,
            "details": obj.get("details"),
            "software_name": obj.get("software_name"),
            "software_upgrade_hops": obj.get("software_upgrade_hops"),
            "software_version": obj.get("software_version"),
            "status": obj.get("status")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

