# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from pypureclient.flasharray.FA_2_4.models.override_check import OverrideCheck
from pypureclient.flasharray.FA_2_4.models.reference import Reference


class SoftwareInstallation(BaseModel):
    """
    SoftwareInstallation
    """
    id: Optional[StrictStr] = Field(default=None, description="A globally unique, system-generated ID. The ID cannot be modified.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the resource. The name cannot be modified.")
    end_time: Optional[StrictInt] = Field(default=None, description="End time in milliseconds since the UNIX epoch.")
    start_time: Optional[StrictInt] = Field(default=None, description="Start time in milliseconds since the UNIX epoch.")
    current_step_id: Optional[StrictStr] = Field(default=None, description="The `id` of the current step, or `null` if the upgrade is not active.")
    details: Optional[StrictStr] = Field(default=None, description="The detailed reason for the `status`.")
    mode: Optional[StrictStr] = Field(default=None, description="Mode that the upgrade is in. Valid values are `check-only`, `interactive`, `semi-interactive`, and `one-click`. In `check-only` mode, the upgrade only runs pre-upgrade checks and returns. In `interactive` mode, the upgrade process pauses at several points, at which users must enter certain commands to proceed. In `semi-interactive` mode, the upgrade pauses if there are any upgrade check failures, and functions like `one-click` mode otherwise. In `one-click` mode, the upgrade proceeds automatically without pausing.")
    override_checks: Optional[conlist(OverrideCheck)] = Field(default=None, description="A list of upgrade checks whose failure is overridden during the upgrade. If any optional `args` are provided, they are validated later when the corresponding check script runs.")
    software: Optional[Reference] = Field(default=None, description="Referenced `software` to which the upgrade belongs.")
    status: Optional[StrictStr] = Field(default=None, description="Status of the upgrade. Valid values are `installing`, `paused`, `aborting`, `aborted`, and `finished`. A status of `installing` indicates that the upgrade is running. A status of `paused` indicates that the upgrade is paused and waiting for user input. A status of `aborting` indicates that the upgrade is being aborted. A status of `aborted` indicates that the upgrade has stopped due to an abort. A status of `finished` indicates that the upgrade has finished successfully.")
    __properties = ["id", "name", "end_time", "start_time", "current_step_id", "details", "mode", "override_checks", "software", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "name",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in override_checks (list)
        if _include_in_dict('override_checks', include_readonly, excluded_fields, none_fields):
            _items = []
            for _item in self.override_checks:
                if _item:
                    _items.append(_item.to_dict(include_readonly=include_readonly))
            _dict['override_checks'] = _items
        # override the default output from pydantic by calling `to_dict()` of software
        if _include_in_dict('software', include_readonly, excluded_fields, none_fields):
            _dict['software'] = self.software.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> SoftwareInstallation:
        """Create an instance of SoftwareInstallation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> SoftwareInstallation:
        """Create an instance of SoftwareInstallation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SoftwareInstallation.parse_obj(obj)

        _obj = SoftwareInstallation.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "end_time": obj.get("end_time"),
            "start_time": obj.get("start_time"),
            "current_step_id": obj.get("current_step_id"),
            "details": obj.get("details"),
            "mode": obj.get("mode"),
            "override_checks": [OverrideCheck.from_dict(_item) for _item in obj.get("override_checks")] if obj.get("override_checks") is not None else None,
            "software": Reference.from_dict(obj.get("software")) if obj.get("software") is not None else None,
            "status": obj.get("status")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

