# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.40
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, conint


class NetworkInterfacePerformanceEth(BaseModel):
    """
    Ethernet network interface statistics.
    """
    flow_control_received_congestion_packets_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Number of congestion control packets received per second.")
    flow_control_received_discarded_packets_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Number of received packets that were physically discarded by the NIC per second due to errors or other reasons.")
    flow_control_received_lossless_bytes_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Bytes received per second with lossless flow control settings.")
    flow_control_received_pause_frames_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Received pause frames per second.")
    flow_control_transmitted_congestion_packets_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Number of congestion control packets transmitted per second.")
    flow_control_transmitted_discarded_packets_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Number of transmitted packets that were physically discarded by the NIC per second due to errors or other reasons.")
    flow_control_transmitted_lossless_bytes_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Bytes transmitted per second with lossless flow control settings.")
    flow_control_transmitted_pause_frames_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Transmitted pause frames per second.")
    other_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="This field has been deprecated. Since Purity version 6.6.8, this will always return `null`. The sum of unspecified reception and transmission errors per second.")
    rdma_received_req_cqe_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="The number of times port detected RDMA CQEs with error per second.")
    rdma_received_sequence_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="The number of received RDMA packet sequence errors per second.")
    rdma_transmitted_local_ack_timeout_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="The number of times RDMA ack timer expired for QPs per second.")
    received_bytes_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Bytes received per second.")
    received_crc_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Reception CRC errors per second.")
    received_frame_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Received packet frame errors per second.")
    received_packets_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Packets received per second.")
    total_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="The sum of all reception and transmission errors per second.")
    transmitted_bytes_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Bytes transmitted per second.")
    transmitted_carrier_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Transmission carrier errors per second.")
    transmitted_dropped_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Transmitted packets dropped per second.")
    transmitted_packets_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Packets transmitted per second.")
    __properties = ["flow_control_received_congestion_packets_per_sec", "flow_control_received_discarded_packets_per_sec", "flow_control_received_lossless_bytes_per_sec", "flow_control_received_pause_frames_per_sec", "flow_control_transmitted_congestion_packets_per_sec", "flow_control_transmitted_discarded_packets_per_sec", "flow_control_transmitted_lossless_bytes_per_sec", "flow_control_transmitted_pause_frames_per_sec", "other_errors_per_sec", "rdma_received_req_cqe_errors_per_sec", "rdma_received_sequence_errors_per_sec", "rdma_transmitted_local_ack_timeout_errors_per_sec", "received_bytes_per_sec", "received_crc_errors_per_sec", "received_frame_errors_per_sec", "received_packets_per_sec", "total_errors_per_sec", "transmitted_bytes_per_sec", "transmitted_carrier_errors_per_sec", "transmitted_dropped_errors_per_sec", "transmitted_packets_per_sec"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> NetworkInterfacePerformanceEth:
        """Create an instance of NetworkInterfacePerformanceEth from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> NetworkInterfacePerformanceEth:
        """Create an instance of NetworkInterfacePerformanceEth from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return NetworkInterfacePerformanceEth.parse_obj(obj)

        _obj = NetworkInterfacePerformanceEth.construct(_fields_set=None, **{
            "flow_control_received_congestion_packets_per_sec": obj.get("flow_control_received_congestion_packets_per_sec"),
            "flow_control_received_discarded_packets_per_sec": obj.get("flow_control_received_discarded_packets_per_sec"),
            "flow_control_received_lossless_bytes_per_sec": obj.get("flow_control_received_lossless_bytes_per_sec"),
            "flow_control_received_pause_frames_per_sec": obj.get("flow_control_received_pause_frames_per_sec"),
            "flow_control_transmitted_congestion_packets_per_sec": obj.get("flow_control_transmitted_congestion_packets_per_sec"),
            "flow_control_transmitted_discarded_packets_per_sec": obj.get("flow_control_transmitted_discarded_packets_per_sec"),
            "flow_control_transmitted_lossless_bytes_per_sec": obj.get("flow_control_transmitted_lossless_bytes_per_sec"),
            "flow_control_transmitted_pause_frames_per_sec": obj.get("flow_control_transmitted_pause_frames_per_sec"),
            "other_errors_per_sec": obj.get("other_errors_per_sec"),
            "rdma_received_req_cqe_errors_per_sec": obj.get("rdma_received_req_cqe_errors_per_sec"),
            "rdma_received_sequence_errors_per_sec": obj.get("rdma_received_sequence_errors_per_sec"),
            "rdma_transmitted_local_ack_timeout_errors_per_sec": obj.get("rdma_transmitted_local_ack_timeout_errors_per_sec"),
            "received_bytes_per_sec": obj.get("received_bytes_per_sec"),
            "received_crc_errors_per_sec": obj.get("received_crc_errors_per_sec"),
            "received_frame_errors_per_sec": obj.get("received_frame_errors_per_sec"),
            "received_packets_per_sec": obj.get("received_packets_per_sec"),
            "total_errors_per_sec": obj.get("total_errors_per_sec"),
            "transmitted_bytes_per_sec": obj.get("transmitted_bytes_per_sec"),
            "transmitted_carrier_errors_per_sec": obj.get("transmitted_carrier_errors_per_sec"),
            "transmitted_dropped_errors_per_sec": obj.get("transmitted_dropped_errors_per_sec"),
            "transmitted_packets_per_sec": obj.get("transmitted_packets_per_sec")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

