# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.41
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from pypureclient.flasharray.FA_2_41.models.fixed_reference import FixedReference
from pypureclient.flasharray.FA_2_41.models.pod_replica_link_reference import PodReplicaLinkReference
from pypureclient.flasharray.FA_2_41.models.reference_with_type import ReferenceWithType


class MappingPolicy(BaseModel):
    """
    MappingPolicy
    """
    id: Optional[StrictStr] = Field(default=None, description="A non-modifiable, globally unique ID chosen by the system.")
    context: Optional[FixedReference] = Field(default=None, description="The context in which the operation was performed. Valid values include a reference to any array which is a member of the same fleet. If the array is not a member of a fleet, `context` will always implicitly be set to the array that received the request. Other parameters provided with the request, such as names of volumes or snapshots, are resolved relative to the provided `context`.")
    direction: Optional[StrictStr] = Field(default=None, description="The direction of replication. Valid values include `inbound` and `outbound`.")
    local_policy: Optional[ReferenceWithType] = Field(default=None, description="Reference to a local policy.")
    mapping: Optional[StrictStr] = Field(default=None, description="The mapping for this policy mapping. Valid values are `connected` and `disconnected`.")
    pod_replica_link: Optional[PodReplicaLinkReference] = Field(default=None, description="Reference to a pod replica link.")
    policy_type: Optional[StrictStr] = Field(default=None, description="The type of policies involved in this policy mapping.")
    remote_policy: Optional[ReferenceWithType] = Field(default=None, description="Reference to a remote policy.")
    __properties = ["id", "context", "direction", "local_policy", "mapping", "pod_replica_link", "policy_type", "remote_policy"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of context
        if _include_in_dict('context', include_readonly, excluded_fields, none_fields):
            _dict['context'] = self.context.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of local_policy
        if _include_in_dict('local_policy', include_readonly, excluded_fields, none_fields):
            _dict['local_policy'] = self.local_policy.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of pod_replica_link
        if _include_in_dict('pod_replica_link', include_readonly, excluded_fields, none_fields):
            _dict['pod_replica_link'] = self.pod_replica_link.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of remote_policy
        if _include_in_dict('remote_policy', include_readonly, excluded_fields, none_fields):
            _dict['remote_policy'] = self.remote_policy.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> MappingPolicy:
        """Create an instance of MappingPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> MappingPolicy:
        """Create an instance of MappingPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return MappingPolicy.parse_obj(obj)

        _obj = MappingPolicy.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "context": FixedReference.from_dict(obj.get("context")) if obj.get("context") is not None else None,
            "direction": obj.get("direction"),
            "local_policy": ReferenceWithType.from_dict(obj.get("local_policy")) if obj.get("local_policy") is not None else None,
            "mapping": obj.get("mapping"),
            "pod_replica_link": PodReplicaLinkReference.from_dict(obj.get("pod_replica_link")) if obj.get("pod_replica_link") is not None else None,
            "policy_type": obj.get("policy_type"),
            "remote_policy": ReferenceWithType.from_dict(obj.get("remote_policy")) if obj.get("remote_policy") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

