# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.42
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictStr


class PresetWorkloadSnapshotRule(BaseModel):
    """
    PresetWorkloadSnapshotRule
    """
    at: Optional[StrictStr] = Field(default=None, description="Specifies the number of milliseconds since midnight at which to take a snapshot. The `at` value cannot be set if the `every` value is not measured in days. The `at` value can only be set on the first rule.")
    every: StrictStr = Field(default=..., description="Specifies the interval between snapshots, in milliseconds. The `every` value for all rules must be multiples of one another. The `every` value must be between five minutes and 400 days for the first rule. The `every` value must be between five minutes and one day for the second rule.")
    keep_for: StrictStr = Field(default=..., description="Specifies the period that snapshots are retained before they are eradicated, in milliseconds. The `keep_for` value must be between 10 minutes and 24855 days for the first rule, and a multiple of a second. The `keep_for` value must be between 10 minutes and 2147483647 days for the second rule, and must be greater than or equal to the `keep_for` value of the first rule.")
    __properties = ["at", "every", "keep_for"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> PresetWorkloadSnapshotRule:
        """Create an instance of PresetWorkloadSnapshotRule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> PresetWorkloadSnapshotRule:
        """Create an instance of PresetWorkloadSnapshotRule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PresetWorkloadSnapshotRule.parse_obj(obj)

        _obj = PresetWorkloadSnapshotRule.construct(_fields_set=None, **{
            "at": obj.get("at"),
            "every": obj.get("every"),
            "keep_for": obj.get("keep_for")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

