# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.42
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist


class PresetWorkloadVolumeConfiguration(BaseModel):
    """
    PresetWorkloadVolumeConfiguration
    """
    count: StrictStr = Field(default=..., description="The number of volumes to provision. Supports parameterization.")
    name: StrictStr = Field(default=..., description="The name of the volume configuration, by which other configuration objects in the preset can reference it. Name must be unique across all configuration objects in the preset.")
    periodic_replication_configurations: Optional[conlist(StrictStr)] = Field(default=None, description="The names of the periodic replication configurations to apply to the volumes.")
    placement_configurations: conlist(StrictStr, max_items=1, min_items=1) = Field(default=..., description="The names of the placement configurations with which to associate the volumes.")
    provisioned_size: StrictStr = Field(default=..., description="The virtual size of each volume. Measured in bytes and must be a multiple of 512. The maximum size is 4503599627370496 (4PB). Supports parameterization.")
    snapshot_configurations: Optional[conlist(StrictStr)] = Field(default=None, description="The names of the snapshot configurations to apply to the volumes.")
    __properties = ["count", "name", "periodic_replication_configurations", "placement_configurations", "provisioned_size", "snapshot_configurations"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> PresetWorkloadVolumeConfiguration:
        """Create an instance of PresetWorkloadVolumeConfiguration from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> PresetWorkloadVolumeConfiguration:
        """Create an instance of PresetWorkloadVolumeConfiguration from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PresetWorkloadVolumeConfiguration.parse_obj(obj)

        _obj = PresetWorkloadVolumeConfiguration.construct(_fields_set=None, **{
            "count": obj.get("count"),
            "name": obj.get("name"),
            "periodic_replication_configurations": obj.get("periodic_replication_configurations"),
            "placement_configurations": obj.get("placement_configurations"),
            "provisioned_size": obj.get("provisioned_size"),
            "snapshot_configurations": obj.get("snapshot_configurations")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

