# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.6
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from pypureclient.flasharray.FA_2_6.models.network_interface_performance_eth import NetworkInterfacePerformanceEth
from pypureclient.flasharray.FA_2_6.models.network_interface_performance_fc import NetworkInterfacePerformanceFc


class NetworkInterfacePerformance(BaseModel):
    """
    NetworkInterfacePerformance
    """
    name: Optional[StrictStr] = Field(default=None, description="A user-specified name. The name must be locally unique and can be changed.")
    eth: Optional[NetworkInterfacePerformanceEth] = None
    fc: Optional[NetworkInterfacePerformanceFc] = None
    interface_type: Optional[StrictStr] = Field(default=None, description="The interface type. Valid values are `eth` and `fc`.")
    time: Optional[StrictInt] = Field(default=None, description="Sample time in milliseconds since UNIX epoch.")
    __properties = ["name", "eth", "fc", "interface_type", "time"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "interface_type",
                "time",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of eth
        if _include_in_dict('eth', include_readonly, excluded_fields, none_fields):
            _dict['eth'] = self.eth.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of fc
        if _include_in_dict('fc', include_readonly, excluded_fields, none_fields):
            _dict['fc'] = self.fc.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> NetworkInterfacePerformance:
        """Create an instance of NetworkInterfacePerformance from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> NetworkInterfacePerformance:
        """Create an instance of NetworkInterfacePerformance from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return NetworkInterfacePerformance.parse_obj(obj)

        _obj = NetworkInterfacePerformance.construct(_fields_set=None, **{
            "name": obj.get("name"),
            "eth": NetworkInterfacePerformanceEth.from_dict(obj.get("eth")) if obj.get("eth") is not None else None,
            "fc": NetworkInterfacePerformanceFc.from_dict(obj.get("fc")) if obj.get("fc") is not None else None,
            "interface_type": obj.get("interface_type"),
            "time": obj.get("time")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

