# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.12, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.12
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from pypureclient.flashblade.FB_2_12.models.fixed_reference import FixedReference


class CrossOriginResourceSharingPolicyRule(BaseModel):
    """
    CrossOriginResourceSharingPolicyRule
    """
    name: Optional[StrictStr] = Field(default=None, description="Name of the object (e.g., a file system or snapshot).")
    allowed_headers: Optional[conlist(StrictStr)] = Field(default=None, description="A list of headers that are permitted to be included in cross-origin requests to access a bucket. The only currently supported allowed header is `*`.")
    allowed_methods: Optional[conlist(StrictStr)] = Field(default=None, description="A list of HTTP methods that are permitted for cross-origin requests to access a bucket. The only currently supported combination of allowed methods is all methods `[\"GET\", \"PUT\", \"HEAD\", \"POST\", \"DELETE\"]`.")
    allowed_origins: Optional[conlist(StrictStr)] = Field(default=None, description="A list of origins (domains) that are permitted to make cross-origin requests to access a bucket. The only currently supported allowed origin is `*`.")
    policy: Optional[FixedReference] = Field(default=None, description="The policy to which this rule belongs.")
    __properties = ["name", "allowed_headers", "allowed_methods", "allowed_origins", "policy"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "name",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of policy
        if _include_in_dict('policy', include_readonly, excluded_fields, none_fields):
            _dict['policy'] = self.policy.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> CrossOriginResourceSharingPolicyRule:
        """Create an instance of CrossOriginResourceSharingPolicyRule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> CrossOriginResourceSharingPolicyRule:
        """Create an instance of CrossOriginResourceSharingPolicyRule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CrossOriginResourceSharingPolicyRule.parse_obj(obj)

        _obj = CrossOriginResourceSharingPolicyRule.construct(_fields_set=None, **{
            "name": obj.get("name"),
            "allowed_headers": obj.get("allowed_headers"),
            "allowed_methods": obj.get("allowed_methods"),
            "allowed_origins": obj.get("allowed_origins"),
            "policy": FixedReference.from_dict(obj.get("policy")) if obj.get("policy") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

