# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.14, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.14
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr


class OauthTokenResponse(BaseModel):
    """
    OauthTokenResponse
    """
    access_token: Optional[StrictStr] = Field(default=None, description="The serialized OAuth 2.0 Bearer token used to perform authenticated requests. The access token must be added to the Authorization header of all API calls.")
    expires_in: Optional[StrictInt] = Field(default=None, description="The duration after which the access token will expire. Measured in seconds. This differs from other duration fields that are expressed in milliseconds.")
    issued_token_type: Optional[StrictStr] = Field(default=None, description="The type of token that is issued. The Pure Storage REST API supports OAuth 2.0 access tokens.")
    token_type: Optional[StrictStr] = Field(default=None, description="Indicates how the API client can use the access token issued. The Pure Storage REST API supports the `Bearer` token.")
    __properties = ["access_token", "expires_in", "issued_token_type", "token_type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> OauthTokenResponse:
        """Create an instance of OauthTokenResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> OauthTokenResponse:
        """Create an instance of OauthTokenResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OauthTokenResponse.parse_obj(obj)

        _obj = OauthTokenResponse.construct(_fields_set=None, **{
            "access_token": obj.get("access_token"),
            "expires_in": obj.get("expires_in"),
            "issued_token_type": obj.get("issued_token_type"),
            "token_type": obj.get("token_type")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

