# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.15, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.15
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr


class WormDataPolicyRetentionConfig(BaseModel):
    """
    WormDataPolicyRetentionConfig
    """
    default_retention: Optional[StrictInt] = Field(default=None, description="Default retention period, in milliseconds. If the access time is not specified when committing a file, then the default retention period is applied.")
    max_retention: Optional[StrictInt] = Field(default=None, description="Maximum retention period, in milliseconds.")
    min_retention: Optional[StrictInt] = Field(default=None, description="Minimum retention period, in milliseconds.")
    mode: Optional[StrictStr] = Field(default=None, description="The type of the retention lock. Valid values is `compliance`.")
    retention_lock: Optional[StrictStr] = Field(default=None, description="If set to `locked`, then the value of retention attributes or policy attributes are not allowed to change. If set to `unlocked`, then the value of the retention attributes and policy attributes are allowed to change. Valid values are `unlocked` and `locked`. It is always allowed to change from `unlocked` to `locked`. Contact Pure Technical Services to change from `locked` to `unlocked`.")
    __properties = ["default_retention", "max_retention", "min_retention", "mode", "retention_lock"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> WormDataPolicyRetentionConfig:
        """Create an instance of WormDataPolicyRetentionConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> WormDataPolicyRetentionConfig:
        """Create an instance of WormDataPolicyRetentionConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return WormDataPolicyRetentionConfig.parse_obj(obj)

        _obj = WormDataPolicyRetentionConfig.construct(_fields_set=None, **{
            "default_retention": obj.get("default_retention"),
            "max_retention": obj.get("max_retention"),
            "min_retention": obj.get("min_retention"),
            "mode": obj.get("mode"),
            "retention_lock": obj.get("retention_lock")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

