# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.16, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.16
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional, Union
from pydantic import BaseModel, Field, StrictInt, StrictStr, confloat, conint
from pypureclient.flashblade.FB_2_16.models.fixed_reference import FixedReference
from pypureclient.flashblade.FB_2_16.models.user import User


class FileSystemUserPerformance(BaseModel):
    """
    FileSystemUserPerformance
    """
    name: Optional[StrictStr] = Field(default=None, description="Name of the object (e.g., a file system or snapshot).")
    bytes_per_op: Optional[Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)]] = Field(default=None, description="Average operation size (read bytes+write bytes/read ops+write ops).")
    bytes_per_read: Optional[Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)]] = Field(default=None, description="Average read size in bytes per read operation.")
    bytes_per_write: Optional[Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)]] = Field(default=None, description="Average write size in bytes per write operation.")
    file_system: Optional[FixedReference] = Field(default=None, description="The file system on which the performance was measured.")
    others_per_sec: Optional[Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)]] = Field(default=None, description="Other operations processed per second.")
    read_bytes_per_sec: Optional[Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)]] = Field(default=None, description="Bytes read per second.")
    reads_per_sec: Optional[Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)]] = Field(default=None, description="Read requests processed per second.")
    time: Optional[StrictInt] = Field(default=None, description="Sample time in milliseconds since UNIX epoch.")
    usec_per_other_op: Optional[Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)]] = Field(default=None, description="Average time, measured in microseconds, it takes the array to process other operations.")
    usec_per_read_op: Optional[Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)]] = Field(default=None, description="Average time, measured in microseconds, it takes the array to process a read request.")
    usec_per_write_op: Optional[Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)]] = Field(default=None, description="Average time, measured in microseconds, it takes the array to process a write request.")
    user: Optional[User] = Field(default=None, description="The user whose performance is represented.")
    write_bytes_per_sec: Optional[Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)]] = Field(default=None, description="Bytes written per second.")
    writes_per_sec: Optional[Union[confloat(ge=0, strict=True), conint(ge=0, strict=True)]] = Field(default=None, description="Write requests processed per second.")
    __properties = ["name", "bytes_per_op", "bytes_per_read", "bytes_per_write", "file_system", "others_per_sec", "read_bytes_per_sec", "reads_per_sec", "time", "usec_per_other_op", "usec_per_read_op", "usec_per_write_op", "user", "write_bytes_per_sec", "writes_per_sec"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "name",
                "bytes_per_op",
                "bytes_per_read",
                "bytes_per_write",
                "others_per_sec",
                "read_bytes_per_sec",
                "reads_per_sec",
                "time",
                "usec_per_other_op",
                "usec_per_read_op",
                "usec_per_write_op",
                "write_bytes_per_sec",
                "writes_per_sec",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of file_system
        if _include_in_dict('file_system', include_readonly, excluded_fields, none_fields):
            _dict['file_system'] = self.file_system.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of user
        if _include_in_dict('user', include_readonly, excluded_fields, none_fields):
            _dict['user'] = self.user.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> FileSystemUserPerformance:
        """Create an instance of FileSystemUserPerformance from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> FileSystemUserPerformance:
        """Create an instance of FileSystemUserPerformance from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FileSystemUserPerformance.parse_obj(obj)

        _obj = FileSystemUserPerformance.construct(_fields_set=None, **{
            "name": obj.get("name"),
            "bytes_per_op": obj.get("bytes_per_op"),
            "bytes_per_read": obj.get("bytes_per_read"),
            "bytes_per_write": obj.get("bytes_per_write"),
            "file_system": FixedReference.from_dict(obj.get("file_system")) if obj.get("file_system") is not None else None,
            "others_per_sec": obj.get("others_per_sec"),
            "read_bytes_per_sec": obj.get("read_bytes_per_sec"),
            "reads_per_sec": obj.get("reads_per_sec"),
            "time": obj.get("time"),
            "usec_per_other_op": obj.get("usec_per_other_op"),
            "usec_per_read_op": obj.get("usec_per_read_op"),
            "usec_per_write_op": obj.get("usec_per_write_op"),
            "user": User.from_dict(obj.get("user")) if obj.get("user") is not None else None,
            "write_bytes_per_sec": obj.get("write_bytes_per_sec"),
            "writes_per_sec": obj.get("writes_per_sec")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

