# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.17, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.17
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from pypureclient.flashblade.FB_2_17.models.network_interfaces_connectors_setting_roce_ecn import NetworkInterfacesConnectorsSettingRoceEcn
from pypureclient.flashblade.FB_2_17.models.network_interfaces_connectors_setting_roce_pfc import NetworkInterfacesConnectorsSettingRocePfc


class NetworkInterfacesConnectorsSettingRoce(BaseModel):
    """
    RoCE(RDMA over Converged Ethernet) configuration for network connectors.
    """
    default_ecn: Optional[NetworkInterfacesConnectorsSettingRoceEcn] = Field(default=None, description="The default ECN(Explicit Congestion Notification) setting for network connectors.")
    default_pfc: Optional[NetworkInterfacesConnectorsSettingRocePfc] = Field(default=None, description="The default PFC(Priority Flow Control) setting for network connectors.")
    enabled: Optional[StrictBool] = Field(default=None, description="If `true`, then RoCE networking is enabled. Otherwise, it is disabled.")
    network_congestion_mode: Optional[StrictStr] = Field(default=None, description="The RoCE network mode to be used. Valid values include `lossy` and `lossless`. For lossy mode, only Explicit Congestion Notification (ECN) is enabled. For lossless mode, both ECN and Priority Flow Control (PFC) are enabled.")
    trust_mode: Optional[StrictStr] = Field(default=None, description="The trust mode of the RoCE network. Valid values include `pcp` and `dscp`.")
    __properties = ["default_ecn", "default_pfc", "enabled", "network_congestion_mode", "trust_mode"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of default_ecn
        if _include_in_dict('default_ecn', include_readonly, excluded_fields, none_fields):
            _dict['default_ecn'] = self.default_ecn.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of default_pfc
        if _include_in_dict('default_pfc', include_readonly, excluded_fields, none_fields):
            _dict['default_pfc'] = self.default_pfc.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> NetworkInterfacesConnectorsSettingRoce:
        """Create an instance of NetworkInterfacesConnectorsSettingRoce from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> NetworkInterfacesConnectorsSettingRoce:
        """Create an instance of NetworkInterfacesConnectorsSettingRoce from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return NetworkInterfacesConnectorsSettingRoce.parse_obj(obj)

        _obj = NetworkInterfacesConnectorsSettingRoce.construct(_fields_set=None, **{
            "default_ecn": NetworkInterfacesConnectorsSettingRoceEcn.from_dict(obj.get("default_ecn")) if obj.get("default_ecn") is not None else None,
            "default_pfc": NetworkInterfacesConnectorsSettingRocePfc.from_dict(obj.get("default_pfc")) if obj.get("default_pfc") is not None else None,
            "enabled": obj.get("enabled"),
            "network_congestion_mode": obj.get("network_congestion_mode"),
            "trust_mode": obj.get("trust_mode")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

