# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.9, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.9
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr


class CertificatePost(BaseModel):
    """
    CertificatePost
    """
    name: Optional[StrictStr] = Field(default=None, description="Name of the object (e.g., a file system or snapshot).")
    certificate: Optional[StrictStr] = Field(default=None, description="The text of the certificate.")
    certificate_type: Optional[StrictStr] = Field(default=None, description="The type of certificate. Possible values are `appliance` and `external`. Certificates of type `appliance` are used by the array to verify its identity to clients. Certificates of type `external` are used by the array to identify external servers to which it is configured to communicate.")
    common_name: Optional[StrictStr] = Field(default=None, description="FQDN or management IP address of the current array.")
    country: Optional[StrictStr] = Field(default=None, description="The country field listed in the certificate.")
    email: Optional[StrictStr] = Field(default=None, description="The email field listed in the certificate.")
    intermediate_certificate: Optional[StrictStr] = Field(default=None, description="Intermediate certificate chains.")
    issued_by: Optional[StrictStr] = Field(default=None, description="Who issued this certificate.")
    issued_to: Optional[StrictStr] = Field(default=None, description="Who this certificate was issued to.")
    key_size: Optional[StrictInt] = Field(default=None, description="The size of the private key for this certificate in bits.")
    locality: Optional[StrictStr] = Field(default=None, description="The locality field listed in the certificate.")
    organization: Optional[StrictStr] = Field(default=None, description="The organization field listed in the certificate.")
    organizational_unit: Optional[StrictStr] = Field(default=None, description="The organizational unit field listed in the certificate.")
    state: Optional[StrictStr] = Field(default=None, description="The state/province field listed in the certificate.")
    status: Optional[StrictStr] = Field(default=None, description="The type of certificate. Valid values are `self-signed` and `imported`.")
    valid_from: Optional[StrictStr] = Field(default=None, description="The start date of when this certificate is valid.")
    valid_to: Optional[StrictStr] = Field(default=None, description="The end date of when this certificate is valid.")
    __properties = ["name", "certificate", "certificate_type", "common_name", "country", "email", "intermediate_certificate", "issued_by", "issued_to", "key_size", "locality", "organization", "organizational_unit", "state", "status", "valid_from", "valid_to"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "name",
                "common_name",
                "country",
                "email",
                "issued_by",
                "issued_to",
                "key_size",
                "locality",
                "organization",
                "organizational_unit",
                "state",
                "status",
                "valid_from",
                "valid_to",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> CertificatePost:
        """Create an instance of CertificatePost from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> CertificatePost:
        """Create an instance of CertificatePost from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CertificatePost.parse_obj(obj)

        _obj = CertificatePost.construct(_fields_set=None, **{
            "name": obj.get("name"),
            "certificate": obj.get("certificate"),
            "certificate_type": obj.get("certificate_type"),
            "common_name": obj.get("common_name"),
            "country": obj.get("country"),
            "email": obj.get("email"),
            "intermediate_certificate": obj.get("intermediate_certificate"),
            "issued_by": obj.get("issued_by"),
            "issued_to": obj.get("issued_to"),
            "key_size": obj.get("key_size"),
            "locality": obj.get("locality"),
            "organization": obj.get("organization"),
            "organizational_unit": obj.get("organizational_unit"),
            "state": obj.get("state"),
            "status": obj.get("status"),
            "valid_from": obj.get("valid_from"),
            "valid_to": obj.get("valid_to")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

