# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.9, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.9
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conint
from pypureclient.flashblade.FB_2_9.models.fixed_reference import FixedReference


class HardwareConnectorPerformance(BaseModel):
    """
    HardwareConnectorPerformance
    """
    id: Optional[StrictStr] = Field(default=None, description="A non-modifiable, globally unique ID chosen by the system.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the object (e.g., a file system or snapshot).")
    link_aggregation_group: Optional[FixedReference] = Field(default=None, description="The link aggregation group which this entity belongs to.")
    other_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="The sum of unspecified reception and transmission errors per second.")
    received_bytes_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Bytes received per second.")
    received_crc_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Reception CRC errors per second.")
    received_frame_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Received packet frame errors per second.")
    received_packets_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Packets received per second.")
    time: Optional[StrictInt] = Field(default=None, description="Sample time in milliseconds since UNIX epoch.")
    total_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="The sum of all reception and transmission errors per second.")
    transmitted_bytes_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Bytes transmitted per second.")
    transmitted_carrier_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Transmission carrier errors per second.")
    transmitted_dropped_errors_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Transmitted packets dropped per second.")
    transmitted_packets_per_sec: Optional[conint(strict=True, ge=0)] = Field(default=None, description="Packets transmitted per second.")
    __properties = ["id", "name", "link_aggregation_group", "other_errors_per_sec", "received_bytes_per_sec", "received_crc_errors_per_sec", "received_frame_errors_per_sec", "received_packets_per_sec", "time", "total_errors_per_sec", "transmitted_bytes_per_sec", "transmitted_carrier_errors_per_sec", "transmitted_dropped_errors_per_sec", "transmitted_packets_per_sec"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "name",
                "other_errors_per_sec",
                "received_bytes_per_sec",
                "received_crc_errors_per_sec",
                "received_frame_errors_per_sec",
                "received_packets_per_sec",
                "time",
                "total_errors_per_sec",
                "transmitted_bytes_per_sec",
                "transmitted_carrier_errors_per_sec",
                "transmitted_dropped_errors_per_sec",
                "transmitted_packets_per_sec",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of link_aggregation_group
        if _include_in_dict('link_aggregation_group', include_readonly, excluded_fields, none_fields):
            _dict['link_aggregation_group'] = self.link_aggregation_group.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> HardwareConnectorPerformance:
        """Create an instance of HardwareConnectorPerformance from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> HardwareConnectorPerformance:
        """Create an instance of HardwareConnectorPerformance from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return HardwareConnectorPerformance.parse_obj(obj)

        _obj = HardwareConnectorPerformance.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "link_aggregation_group": FixedReference.from_dict(obj.get("link_aggregation_group")) if obj.get("link_aggregation_group") is not None else None,
            "other_errors_per_sec": obj.get("other_errors_per_sec"),
            "received_bytes_per_sec": obj.get("received_bytes_per_sec"),
            "received_crc_errors_per_sec": obj.get("received_crc_errors_per_sec"),
            "received_frame_errors_per_sec": obj.get("received_frame_errors_per_sec"),
            "received_packets_per_sec": obj.get("received_packets_per_sec"),
            "time": obj.get("time"),
            "total_errors_per_sec": obj.get("total_errors_per_sec"),
            "transmitted_bytes_per_sec": obj.get("transmitted_bytes_per_sec"),
            "transmitted_carrier_errors_per_sec": obj.get("transmitted_carrier_errors_per_sec"),
            "transmitted_dropped_errors_per_sec": obj.get("transmitted_dropped_errors_per_sec"),
            "transmitted_packets_per_sec": obj.get("transmitted_packets_per_sec")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

