# coding: utf-8

"""
    Pure1 Public REST API

    Pure1 Public REST API, developed by [Pure Storage, Inc.](https://www.purestorage.com)   The Pure1 REST API 2.0 offers one single form of authentication: OAuth 2.0 via the [Token Exchange protocol](https://datatracker.ietf.org/doc/draft-ietf-oauth-token-exchange).  OAuth 2.0 is an open protocol to allow secure authorization in a simple and standard method from web, mobile, desktop and background applications.  Note that the [Authentication](#section/Authentication) section below mentions 'API Key' as the security scheme type. This is solely for the purpose of allowing testing this API with [Swagger UI](https://static.pure1.purestorage.com/api-swagger/index.html).  [Knowledge base reference documentation](https://support.purestorage.com/Pure1/Pure1_Manage/Pure1_Manage_-_REST_API/Pure1_Manage_-_REST_API__Reference)

    The version of the OpenAPI document: 1.5
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional
from pydantic import BaseModel, Field
from pypureclient.pure1.Pure1_1_5.models.asset_space_total_used_ratio import AssetSpaceTotalUsedRatio
from pypureclient.pure1.Pure1_1_5.models.current_metric import CurrentMetric


class AssetSpace(BaseModel):
    """
    AssetSpace
    """
    capacity: Optional[CurrentMetric] = Field(default=None, description="The usable capacity of the appliance.")
    total_used: Optional[CurrentMetric] = Field(default=None, description="The total space contributed by customer data.")
    total_used_ratio: Optional[AssetSpaceTotalUsedRatio] = None
    __properties = ["capacity", "total_used", "total_used_ratio"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of capacity
        if _include_in_dict('capacity', include_readonly, excluded_fields, none_fields):
            _dict['capacity'] = self.capacity.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of total_used
        if _include_in_dict('total_used', include_readonly, excluded_fields, none_fields):
            _dict['total_used'] = self.total_used.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of total_used_ratio
        if _include_in_dict('total_used_ratio', include_readonly, excluded_fields, none_fields):
            _dict['total_used_ratio'] = self.total_used_ratio.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> AssetSpace:
        """Create an instance of AssetSpace from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> AssetSpace:
        """Create an instance of AssetSpace from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AssetSpace.parse_obj(obj)

        _obj = AssetSpace.construct(_fields_set=None, **{
            "capacity": CurrentMetric.from_dict(obj.get("capacity")) if obj.get("capacity") is not None else None,
            "total_used": CurrentMetric.from_dict(obj.get("total_used")) if obj.get("total_used") is not None else None,
            "total_used_ratio": AssetSpaceTotalUsedRatio.from_dict(obj.get("total_used_ratio")) if obj.get("total_used_ratio") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

