# coding: utf-8

"""
    Pure1 Public REST API

    Pure1 Public REST API, developed by [Pure Storage, Inc.](https://www.purestorage.com)   The Pure1 REST API 2.0 offers one single form of authentication: OAuth 2.0 via the [Token Exchange protocol](https://datatracker.ietf.org/doc/draft-ietf-oauth-token-exchange).  OAuth 2.0 is an open protocol to allow secure authorization in a simple and standard method from web, mobile, desktop and background applications.  Note that the [Authentication](#section/Authentication) section below mentions 'API Key' as the security scheme type. This is solely for the purpose of allowing testing this API with [Swagger UI](https://static.pure1.purestorage.com/api-swagger/index.html).  [Knowledge base reference documentation](https://support.purestorage.com/Pure1/Pure1_Manage/Pure1_Manage_-_REST_API/Pure1_Manage_-_REST_API__Reference)

    The version of the OpenAPI document: 1.5
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from pypureclient.pure1.Pure1_1_5.models.evergreen_forever_and_foundation_details import EvergreenForeverAndFoundationDetails
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

SUBSCRIPTIONALLOFSERVICEDETAILS_ONE_OF_SCHEMAS = ["EvergreenForeverAndFoundationDetails", "object"]

class SubscriptionAllOfServiceDetails(BaseModel):
    """
    Additional details for the given service.
    """
    # data type: EvergreenForeverAndFoundationDetails
    oneof_schema_1_validator: Optional[EvergreenForeverAndFoundationDetails] = None
    # data type: object
    oneof_schema_2_validator: Optional[Dict[str, Any]] = None
    if TYPE_CHECKING:
        actual_instance: Union[EvergreenForeverAndFoundationDetails, object]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(SUBSCRIPTIONALLOFSERVICEDETAILS_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = SubscriptionAllOfServiceDetails.construct()
        error_messages = []
        match = 0
        # validate data type: EvergreenForeverAndFoundationDetails
        if not isinstance(v, EvergreenForeverAndFoundationDetails):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EvergreenForeverAndFoundationDetails`")
        else:
            match += 1
        # validate data type: object
        try:
            instance.oneof_schema_2_validator = v
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in SubscriptionAllOfServiceDetails with oneOf schemas: EvergreenForeverAndFoundationDetails, object. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in SubscriptionAllOfServiceDetails with oneOf schemas: EvergreenForeverAndFoundationDetails, object. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> SubscriptionAllOfServiceDetails:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> SubscriptionAllOfServiceDetails:
        """Returns the object represented by the json string"""
        instance = SubscriptionAllOfServiceDetails.construct()
        error_messages = []
        match = 0

        # deserialize data into EvergreenForeverAndFoundationDetails
        try:
            instance.actual_instance = EvergreenForeverAndFoundationDetails.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into object
        try:
            # validation
            instance.oneof_schema_2_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.oneof_schema_2_validator
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into SubscriptionAllOfServiceDetails with oneOf schemas: EvergreenForeverAndFoundationDetails, object. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into SubscriptionAllOfServiceDetails with oneOf schemas: EvergreenForeverAndFoundationDetails, object. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


